From 69f581bbf7ff7cc545a27277d78626b8f5554bcc Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Laur=C3=A9line=20Gu=C3=A9rin?= <zebuline@entrouvert.com>
Date: Thu, 29 Apr 2021 18:11:24 +0200
Subject: [PATCH] misc: fix pylint consider-using-with (#53406)

---
 pylint.rc                                     |   1 -
 tests/admin_pages/test_all.py                 |  10 +-
 tests/admin_pages/test_datasource.py          |  31 +-
 tests/admin_pages/test_form.py                |  12 +-
 tests/admin_pages/test_settings.py            |  48 ++--
 tests/api/test_custom_view.py                 |   8 +-
 tests/api/test_formdata.py                    |  11 +-
 tests/backoffice_pages/test_all.py            |  62 ++--
 tests/backoffice_pages/test_carddata.py       |  15 +-
 tests/backoffice_pages/test_custom_view.py    |  15 +-
 tests/backoffice_pages/test_export.py         |  29 +-
 tests/backoffice_pages/test_submission.py     |  15 +-
 tests/form_pages/test_all.py                  |  31 +-
 tests/form_pages/test_formdata.py             |  31 +-
 tests/test_categories.py                      |   5 +-
 tests/test_datasource.py                      | 272 ++++++++----------
 tests/test_ezt.py                             |   5 +-
 tests/test_hobo.py                            |  25 +-
 tests/test_misc.py                            |  56 ++--
 tests/test_publisher.py                       |  14 +-
 tests/test_saml_auth.py                       |  15 +-
 tests/test_workflows.py                       |  12 +-
 tests/utilities.py                            |  25 +-
 wcs/admin/forms.py                            |  12 +-
 wcs/admin/settings.py                         | 214 +++++++-------
 wcs/admin/workflows.py                        |   8 +-
 wcs/backoffice/management.py                  |  22 +-
 wcs/ctl/backup.py                             |  20 +-
 wcs/ctl/management/commands/convert_to_sql.py |  30 +-
 wcs/ctl/restore.py                            |  11 +-
 wcs/publisher.py                              | 241 ++++++++--------
 wcs/qommon/admin/menu.py                      |  20 +-
 wcs/qommon/form.py                            |   5 +-
 wcs/qommon/misc.py                            |   3 +-
 wcs/qommon/ods.py                             |  31 +-
 wcs/qommon/storage.py                         |   2 +-
 wcs/qommon/upload_storage.py                  |  13 +-
 wcs/qommon/vendor/locket.py                   |  11 +-
 wcs/qommon/x509utils.py                       |   8 +-
 wcs/wf/export_to_model.py                     |  44 ++-
 wcs/workflows.py                              |   2 +-
 41 files changed, 691 insertions(+), 754 deletions(-)

diff --git a/pylint.rc b/pylint.rc
index f5c668c6..fd58728d 100644
--- a/pylint.rc
+++ b/pylint.rc
@@ -13,7 +13,6 @@ disable=
     consider-using-dict-comprehension,
     consider-using-max-builtin,
     consider-using-set-comprehension,
-    consider-using-with,
     cyclic-import,
     duplicate-code,
     fixme,
diff --git a/tests/admin_pages/test_all.py b/tests/admin_pages/test_all.py
index bc8d1dde..f24dc490 100644
--- a/tests/admin_pages/test_all.py
+++ b/tests/admin_pages/test_all.py
@@ -115,15 +115,13 @@ def test_admin_for_all(pub):
         resp = get_app(pub).get('/backoffice/settings/', status=200)
 
         # check it doesn't work with a non-empty ADMIN_FOR_ALL file
-        fd = open(os.path.join(pub.app_dir, 'ADMIN_FOR_ALL'), 'w')
-        fd.write('x.x.x.x')
-        fd.close()
+        with open(os.path.join(pub.app_dir, 'ADMIN_FOR_ALL'), 'w') as fd:
+            fd.write('x.x.x.x')
         resp = get_app(pub).get('/backoffice/settings/', status=302)
 
         # check it works if the file contains the user IP address
-        fd = open(os.path.join(pub.app_dir, 'ADMIN_FOR_ALL'), 'w')
-        fd.write('127.0.0.1')
-        fd.close()
+        with open(os.path.join(pub.app_dir, 'ADMIN_FOR_ALL'), 'w') as fd:
+            fd.write('127.0.0.1')
         resp = get_app(pub).get('/backoffice/settings/', status=200)
 
         # check it's also ok if the user is logged in but doesn't have the
diff --git a/tests/admin_pages/test_datasource.py b/tests/admin_pages/test_datasource.py
index 5611f0c3..f8d3e50b 100644
--- a/tests/admin_pages/test_datasource.py
+++ b/tests/admin_pages/test_datasource.py
@@ -251,9 +251,8 @@ def test_data_sources_view(pub):
 
     # check json
     json_file_path = os.path.join(pub.app_dir, 'test.json')
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
 
     data_source.data_source = {'type': 'json', 'value': 'file://%s' % json_file_path}
     data_source.store()
@@ -263,9 +262,8 @@ def test_data_sources_view(pub):
     assert 'foo' in resp.text
 
     # with other attributes
-    json_file = open(json_file_path, 'w')
-    json.dump({'results': [{'pk': '1', 'label': 'foo'}, {'pk': '2'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'results': [{'pk': '1', 'label': 'foo'}, {'pk': '2'}]}, json_file)
 
     data_source.data_attribute = 'results'
     data_source.id_attribute = 'pk'
@@ -288,17 +286,16 @@ def test_data_sources_view(pub):
 
     # check geojson
     geojson_file_path = os.path.join(pub.app_dir, 'test.geojson')
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '1', 'text': 'foo', 'label': 'foo'}},
-                {'properties': {'id': '2', 'text': 'bar', 'label': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '1', 'text': 'foo', 'label': 'foo'}},
+                    {'properties': {'id': '2', 'text': 'bar', 'label': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     data_source.data_source = {'type': 'geojson', 'value': 'file://%s' % geojson_file_path}
     data_source.store()
     with HttpRequestsMocking():
diff --git a/tests/admin_pages/test_form.py b/tests/admin_pages/test_form.py
index 51f9b0d5..b49b777a 100644
--- a/tests/admin_pages/test_form.py
+++ b/tests/admin_pages/test_form.py
@@ -2439,18 +2439,18 @@ def test_form_archive(pub):
     resp = resp.click(href='archive')
     resp = resp.form.submit('submit')
     assert resp.content_type == 'application/x-wcs-archive'
-    tf = tarfile.open(fileobj=io.BytesIO(resp.body))
-    assert 'formdef' in [x.name for x in tf.getmembers()]
-    assert len(tf.getmembers()) == 8  # 7 formdata + 1 formdef
+    with tarfile.open(fileobj=io.BytesIO(resp.body)) as tf:
+        assert 'formdef' in [x.name for x in tf.getmembers()]
+        assert len(tf.getmembers()) == 8  # 7 formdata + 1 formdef
 
     # second archive, it shouldn't get anything (but the formdef)
     resp = app.get('/backoffice/forms/1/')
     resp = resp.click(href='archive')
     resp = resp.form.submit('submit')
     assert resp.content_type == 'application/x-wcs-archive'
-    tf = tarfile.open(fileobj=io.BytesIO(resp.body))
-    assert 'formdef' in [x.name for x in tf.getmembers()]
-    assert len(tf.getmembers()) == 1  # 0 formdata + 1 formdef
+    with tarfile.open(fileobj=io.BytesIO(resp.body)) as tf:
+        assert 'formdef' in [x.name for x in tf.getmembers()]
+        assert len(tf.getmembers()) == 1  # 0 formdata + 1 formdef
 
 
 def test_form_overwrite(pub):
diff --git a/tests/admin_pages/test_settings.py b/tests/admin_pages/test_settings.py
index 587c7077..67becb11 100644
--- a/tests/admin_pages/test_settings.py
+++ b/tests/admin_pages/test_settings.py
@@ -115,8 +115,8 @@ def test_settings_export_import(pub):
     assert 'completed' in resp.text
     resp = resp.click('Download Export')
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
     assert len(filelist) == 0
 
     # check afterjob ajax call
@@ -166,8 +166,8 @@ def test_settings_export_import(pub):
     resp = resp.follow()
     resp = resp.click('Download Export')
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
     assert 'formdefs/1' not in filelist
     assert 'formdefs_xml/1' in filelist
     assert 'carddefs/1' not in filelist
@@ -249,8 +249,8 @@ def test_settings_export_import(pub):
     resp = resp.follow()
     resp = resp.click('Download Export')
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
     assert 'formdefs_xml/%s' % formdef.id in filelist
     assert 'workflows_xml/%s' % workflow.id in filelist
     assert 'roles_xml/%s' % role.id not in filelist
@@ -283,8 +283,8 @@ def test_settings_export_import(pub):
     resp = resp.follow()
     resp = resp.click('Download Export')
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
     assert len([x for x in filelist if 'roles_xml/' in x]) == 0
 
     # check an error is displayed if such an import is then used and roles are
@@ -305,11 +305,13 @@ def test_settings_themes(pub):
     # create mock theme
     os.mkdir(os.path.join(pub.app_dir, 'themes'))
     os.mkdir(os.path.join(pub.app_dir, 'themes', 'test'))
-    fd = open(os.path.join(pub.app_dir, 'themes', 'test', 'desc.xml'), 'w')
-    fd.write(
-        '<?xml version="1.0"?>' '<theme name="test" version="1.0">' '  <label>Test Theme</label>' '</theme>'
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'themes', 'test', 'desc.xml'), 'w') as fd:
+        fd.write(
+            '<?xml version="1.0"?>'
+            '<theme name="test" version="1.0">'
+            '  <label>Test Theme</label>'
+            '</theme>'
+        )
 
     resp = app.get('/backoffice/settings/themes')
     assert 'biglist themes' in resp.text
@@ -831,17 +833,17 @@ def test_settings_theme_download_upload(pub):
     resp = app.get('/backoffice/settings/themes')
     resp = resp.click('download', index=0)
     assert resp.headers['content-type'] == 'application/zip'
+
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
-    assert 'alto/icon.png' in filelist
-    assert 'alto/desc.xml' in filelist
-    assert 'alto/template.ezt' in filelist
-    assert 'alto/wcs.css' in filelist
-
-    # modify it
-    zipf.writestr('alto/foobar.txt', 'XXX')
-    zipf.close()
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
+        assert 'alto/icon.png' in filelist
+        assert 'alto/desc.xml' in filelist
+        assert 'alto/template.ezt' in filelist
+        assert 'alto/wcs.css' in filelist
+
+        # modify it
+        zipf.writestr('alto/foobar.txt', 'XXX')
 
     # upload it
     resp = app.get('/backoffice/settings/themes')
diff --git a/tests/api/test_custom_view.py b/tests/api/test_custom_view.py
index 1544fed6..94a848d6 100644
--- a/tests/api/test_custom_view.py
+++ b/tests/api/test_custom_view.py
@@ -244,8 +244,8 @@ def test_api_ods_formdata_custom_view(pub, local_user):
 
     # check it now gets the data
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods', user=local_user))
-    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
-    ods_sheet = ET.parse(zipf.open('content.xml'))
+    with zipfile.ZipFile(io.BytesIO(resp.body)) as zipf:
+        ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 11
 
     pub.custom_view_class.wipe()
@@ -258,8 +258,8 @@ def test_api_ods_formdata_custom_view(pub, local_user):
     custom_view.store()
 
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods/custom-view', user=local_user))
-    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
-    ods_sheet = ET.parse(zipf.open('content.xml'))
+    with zipfile.ZipFile(io.BytesIO(resp.body)) as zipf:
+        ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 21
 
 
diff --git a/tests/api/test_formdata.py b/tests/api/test_formdata.py
index f882c1a2..96264b88 100644
--- a/tests/api/test_formdata.py
+++ b/tests/api/test_formdata.py
@@ -45,12 +45,13 @@ def pub(request, emails):
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
 
-    open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w').write(
-        '''\
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''\
 [api-secrets]
 coucou = 1234
 '''
-    )
+        )
 
     return pub
 
@@ -965,8 +966,8 @@ def test_api_ods_formdata(pub, local_user):
 
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods', user=local_user))
     assert resp.content_type == 'application/vnd.oasis.opendocument.spreadsheet'
-    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
-    ods_sheet = ET.parse(zipf.open('content.xml'))
+    with zipfile.ZipFile(io.BytesIO(resp.body)) as zipf:
+        ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 311
 
 
diff --git a/tests/backoffice_pages/test_all.py b/tests/backoffice_pages/test_all.py
index cfa063fb..03ce3c81 100644
--- a/tests/backoffice_pages/test_all.py
+++ b/tests/backoffice_pages/test_all.py
@@ -66,14 +66,13 @@ def pub(request, emails):
     pub.cfg['identification'] = {'methods': ['password']}
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write(
-        '''
-[api-secrets]
-coucou = 1234
-'''
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
+    [api-secrets]
+    coucou = 1234
+    '''
+        )
 
     return pub
 
@@ -528,9 +527,8 @@ def test_backoffice_listing_order(pub):
     if not pub.site_options.has_section('options'):
         pub.site_options.add_section('options')
         pub.site_options.set('options', 'default-sort-order', '-last_update_time')
-        fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-        pub.site_options.write(fd)
-        fd.close()
+        with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+            pub.site_options.write(fd)
 
     resp = app.get('/backoffice/management/form-title/')
     assert resp.text.count('data-link') == 17
@@ -605,9 +603,8 @@ def test_backoffice_channel_column(pub):
     if not pub.site_options.has_section('variables'):
         pub.site_options.add_section('variables')
     pub.site_options.set('variables', 'welco_url', 'xxx')
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
 
     create_superuser(pub)
     create_environment(pub)
@@ -1885,9 +1882,8 @@ def test_backoffice_map(pub):
         pub.site_options.add_section('options')
 
     pub.site_options.set('options', 'map-tile-urltemplate', 'https://{s}.tile.example.net/{z}/{x}/{y}.png')
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
 
     resp = app.get('/backoffice/management/form-title/')
     resp = resp.click('Plot on a Map')
@@ -2085,17 +2081,17 @@ def test_backoffice_download_as_zip(pub):
     resp = app.get('/backoffice/management/form-title/%s/' % number31.id)
     resp = resp.click('Download all files as .zip')
     zip_content = io.BytesIO(resp.body)
-    zipf = zipfile.ZipFile(zip_content, 'a')
-    filelist = zipf.namelist()
-    assert set(filelist) == {'1_bar', '2_bar'}
-    for zipinfo in zipf.infolist():
-        content = zipf.read(zipinfo)
-        if zipinfo.filename == '1_bar':
-            assert content == b'hello world'
-        elif zipinfo.filename == '2_bar':
-            assert content == b'hello world2'
-        else:
-            assert False  # unknown zip part
+    with zipfile.ZipFile(zip_content, 'a') as zipf:
+        filelist = zipf.namelist()
+        assert set(filelist) == {'1_bar', '2_bar'}
+        for zipinfo in zipf.infolist():
+            content = zipf.read(zipinfo)
+            if zipinfo.filename == '1_bar':
+                assert content == b'hello world'
+            elif zipinfo.filename == '2_bar':
+                assert content == b'hello world2'
+            else:
+                assert False  # unknown zip part
 
 
 def test_backoffice_sidebar_user_template(pub):
@@ -3011,9 +3007,8 @@ def test_global_listing(pub):
     if not pub.site_options.has_section('variables'):
         pub.site_options.add_section('variables')
     pub.site_options.set('variables', 'welco_url', 'xxx')
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
 
     resp = app.get('/backoffice/management/listing?limit=500')
     formdata = formdef.data_class().select(lambda x: x.status == 'wf-new')[0]
@@ -3611,9 +3606,8 @@ def test_per_user_view(pub):
     if not pub.site_options.has_section('options'):
         pub.site_options.add_section('options')
         pub.site_options.set('options', 'per-user-view', 'true')
-        fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-        pub.site_options.write(fd)
-        fd.close()
+        with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+            pub.site_options.write(fd)
 
     resp = app.get('/backoffice/management/').follow()
     assert 'Per User View' in resp.text
diff --git a/tests/backoffice_pages/test_carddata.py b/tests/backoffice_pages/test_carddata.py
index f0eaaade..6b4042a5 100644
--- a/tests/backoffice_pages/test_carddata.py
+++ b/tests/backoffice_pages/test_carddata.py
@@ -35,14 +35,13 @@ def pub(request, emails):
     pub.cfg['identification'] = {'methods': ['password']}
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write(
-        '''
-[api-secrets]
-coucou = 1234
-'''
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
+    [api-secrets]
+    coucou = 1234
+    '''
+        )
 
     return pub
 
diff --git a/tests/backoffice_pages/test_custom_view.py b/tests/backoffice_pages/test_custom_view.py
index 7f6329f2..dda8b07a 100644
--- a/tests/backoffice_pages/test_custom_view.py
+++ b/tests/backoffice_pages/test_custom_view.py
@@ -31,14 +31,13 @@ def pub(request, emails):
     pub.cfg['identification'] = {'methods': ['password']}
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write(
-        '''
-[api-secrets]
-coucou = 1234
-'''
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
+    [api-secrets]
+    coucou = 1234
+    '''
+        )
 
     return pub
 
diff --git a/tests/backoffice_pages/test_export.py b/tests/backoffice_pages/test_export.py
index ef627e0f..cd603cf1 100644
--- a/tests/backoffice_pages/test_export.py
+++ b/tests/backoffice_pages/test_export.py
@@ -37,14 +37,13 @@ def pub(request, emails):
     pub.cfg['identification'] = {'methods': ['password']}
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write(
-        '''
-[api-secrets]
-coucou = 1234
-'''
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
+    [api-secrets]
+    coucou = 1234
+    '''
+        )
 
     return pub
 
@@ -236,9 +235,8 @@ def test_backoffice_csv_export_channel(pub):
     if not pub.site_options.has_section('variables'):
         pub.site_options.add_section('variables')
     pub.site_options.set('variables', 'welco_url', 'xxx')
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
 
     create_superuser(pub)
 
@@ -272,9 +270,8 @@ def test_backoffice_csv_export_channel(pub):
 
 
 def test_backoffice_csv_export_anonymised(pub):
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
 
     create_superuser(pub)
 
@@ -483,8 +480,8 @@ def test_backoffice_ods(pub):
     assert 'filename=form-title.ods' in resp.headers['content-disposition']
     assert resp.body[:2] == b'PK'  # ods has a zip container
 
-    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
-    ods_sheet = ET.parse(zipf.open('content.xml'))
+    with zipfile.ZipFile(io.BytesIO(resp.body)) as zipf:
+        ods_sheet = ET.parse(zipf.open('content.xml'))
     # check the ods contains a link to the document
     elem = ods_sheet.findall('.//{%s}a' % ods.NS['text'])[0]
     assert (
diff --git a/tests/backoffice_pages/test_submission.py b/tests/backoffice_pages/test_submission.py
index 74cf60e0..25013134 100644
--- a/tests/backoffice_pages/test_submission.py
+++ b/tests/backoffice_pages/test_submission.py
@@ -37,14 +37,13 @@ def pub(request, emails):
     pub.cfg['identification'] = {'methods': ['password']}
     pub.cfg['language'] = {'language': 'en'}
     pub.write_cfg()
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write(
-        '''
-[api-secrets]
-coucou = 1234
-'''
-    )
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
+    [api-secrets]
+    coucou = 1234
+    '''
+        )
 
     return pub
 
diff --git a/tests/form_pages/test_all.py b/tests/form_pages/test_all.py
index 9321a80a..7b87c58c 100644
--- a/tests/form_pages/test_all.py
+++ b/tests/form_pages/test_all.py
@@ -56,22 +56,21 @@ from ..utilities import clean_temporary_pub, create_temporary_pub, get_app, logi
 
 
 def assert_equal_zip(stream1, stream2):
-    z1 = zipfile.ZipFile(stream1)
-    z2 = zipfile.ZipFile(stream2)
-    assert set(z1.namelist()) == set(z2.namelist())
-    for name in z1.namelist():
-        if name == 'styles.xml':
-            continue
-        if name in ['content.xml', 'meta.xml']:
-            t1, t2 = ET.tostring(ET.XML(z1.read(name))), ET.tostring(ET.XML(z2.read(name)))
-            try:
-                # >= python 3.8: tostring preserves attribute order; use canonicalize to sort them
-                t1, t2 = ET.canonicalize(t1), ET.canonicalize(t2)
-            except AttributeError:
-                pass
-        else:
-            t1, t2 = z1.read(name), z2.read(name)
-        assert t1 == t2, 'file "%s" differs' % name
+    with zipfile.ZipFile(stream1) as z1, zipfile.ZipFile(stream2) as z2:
+        assert set(z1.namelist()) == set(z2.namelist())
+        for name in z1.namelist():
+            if name == 'styles.xml':
+                continue
+            if name in ['content.xml', 'meta.xml']:
+                t1, t2 = ET.tostring(ET.XML(z1.read(name))), ET.tostring(ET.XML(z2.read(name)))
+                try:
+                    # >= python 3.8: tostring preserves attribute order; use canonicalize to sort them
+                    t1, t2 = ET.canonicalize(t1), ET.canonicalize(t2)
+                except AttributeError:
+                    pass
+            else:
+                t1, t2 = z1.read(name), z2.read(name)
+            assert t1 == t2, 'file "%s" differs' % name
 
 
 def pytest_generate_tests(metafunc):
diff --git a/tests/form_pages/test_formdata.py b/tests/form_pages/test_formdata.py
index aca72110..d5f6f6ea 100644
--- a/tests/form_pages/test_formdata.py
+++ b/tests/form_pages/test_formdata.py
@@ -60,22 +60,21 @@ def teardown_module(module):
 
 
 def assert_equal_zip(stream1, stream2):
-    z1 = zipfile.ZipFile(stream1)
-    z2 = zipfile.ZipFile(stream2)
-    assert set(z1.namelist()) == set(z2.namelist())
-    for name in z1.namelist():
-        if name == 'styles.xml':
-            continue
-        if name in ['content.xml', 'meta.xml']:
-            t1, t2 = ET.tostring(ET.XML(z1.read(name))), ET.tostring(ET.XML(z2.read(name)))
-            try:
-                # >= python 3.8: tostring preserves attribute order; use canonicalize to sort them
-                t1, t2 = ET.canonicalize(t1), ET.canonicalize(t2)
-            except AttributeError:
-                pass
-        else:
-            t1, t2 = z1.read(name), z2.read(name)
-        assert t1 == t2, 'file "%s" differs' % name
+    with zipfile.ZipFile(stream1) as z1, zipfile.ZipFile(stream2) as z2:
+        assert set(z1.namelist()) == set(z2.namelist())
+        for name in z1.namelist():
+            if name == 'styles.xml':
+                continue
+            if name in ['content.xml', 'meta.xml']:
+                t1, t2 = ET.tostring(ET.XML(z1.read(name))), ET.tostring(ET.XML(z2.read(name)))
+                try:
+                    # >= python 3.8: tostring preserves attribute order; use canonicalize to sort them
+                    t1, t2 = ET.canonicalize(t1), ET.canonicalize(t2)
+                except AttributeError:
+                    pass
+            else:
+                t1, t2 = z1.read(name), z2.read(name)
+            assert t1 == t2, 'file "%s" differs' % name
 
 
 def test_formdata_attachment_download(pub):
diff --git a/tests/test_categories.py b/tests/test_categories.py
index 78e8be3b..8ad63528 100644
--- a/tests/test_categories.py
+++ b/tests/test_categories.py
@@ -123,9 +123,8 @@ def test_load_old_pickle():
     test.description = 'Hello world'
 
     os.mkdir(os.path.join(pub.app_dir, 'categories'))
-    fd = open(os.path.join(pub.app_dir, 'categories', '1'), 'wb')
-    pickle.dump(test, fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'categories', '1'), 'wb') as fd:
+        pickle.dump(test, fd)
 
     test2 = Category.get(1)
     assert test.id == test2.id
